Index: src/molecule_graph.cpp
===================================================================
--- src/molecule_graph.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/molecule_graph.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -17,4 +17,6 @@
 #include "memoryallocator.hpp"
 #include "molecule.hpp"
+#include "World.hpp"
+#include "Helpers/fast_functions.hpp"
 
 struct BFSAccounting
@@ -58,10 +60,10 @@
 
   if (!input) {
-    Log() << Verbose(1) << "Opening silica failed \n";
+    DoLog(1) && (Log() << Verbose(1) << "Opening silica failed \n");
   };
 
   *input >> ws >> atom1;
   *input >> ws >> atom2;
-  Log() << Verbose(1) << "Scanning file\n";
+  DoLog(1) && (Log() << Verbose(1) << "Scanning file\n");
   while (!input->eof()) // Check whether we read everything already
   {
@@ -106,4 +108,5 @@
   LinkedCell *LC = NULL;
   bool free_BG = false;
+  double * const cell_size = World::getInstance().getDomain();
 
   if (BG == NULL) {
@@ -113,5 +116,5 @@
 
   BondDistance = bonddistance; // * ((IsAngstroem) ? 1. : 1./AtomicLengthToAngstroem);
-  Log() << Verbose(0) << "Begin of CreateAdjacencyList." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Begin of CreateAdjacencyList." << endl);
   // remove every bond from the list
   bond *Binder = NULL;
@@ -126,12 +129,12 @@
   // count atoms in molecule = dimension of matrix (also give each unique name and continuous numbering)
   CountAtoms();
-  Log() << Verbose(1) << "AtomCount " << AtomCount << " and bonddistance is " << bonddistance << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "AtomCount " << AtomCount << " and bonddistance is " << bonddistance << "." << endl);
 
   if ((AtomCount > 1) && (bonddistance > 1.)) {
-    Log() << Verbose(2) << "Creating Linked Cell structure ... " << endl;
+    DoLog(2) && (Log() << Verbose(2) << "Creating Linked Cell structure ... " << endl);
     LC = new LinkedCell(this, bonddistance);
 
     // create a list to map Tesselpoint::nr to atom *
-    Log() << Verbose(2) << "Creating TesselPoint to atom map ... " << endl;
+    DoLog(2) && (Log() << Verbose(2) << "Creating TesselPoint to atom map ... " << endl);
     AtomMap = Calloc<atom *> (AtomCount, "molecule::CreateAdjacencyList - **AtomCount");
     Walker = start;
@@ -142,33 +145,39 @@
 
     // 3a. go through every cell
-    Log() << Verbose(2) << "Celling ... " << endl;
+    DoLog(2) && (Log() << Verbose(2) << "Celling ... " << endl);
     for (LC->n[0] = 0; LC->n[0] < LC->N[0]; LC->n[0]++)
       for (LC->n[1] = 0; LC->n[1] < LC->N[1]; LC->n[1]++)
         for (LC->n[2] = 0; LC->n[2] < LC->N[2]; LC->n[2]++) {
-          const LinkedNodes *List = LC->GetCurrentCell();
-          //Log() << Verbose(2) << "Current cell is " << LC->n[0] << ", " << LC->n[1] << ", " << LC->n[2] << " with No. " << LC->index << " containing " << List->size() << " points." << endl;
+          const LinkedCell::LinkedNodes *List = LC->GetCurrentCell();
+//          Log() << Verbose(2) << "Current cell is " << LC->n[0] << ", " << LC->n[1] << ", " << LC->n[2] << " with No. " << LC->index << " containing " << List->size() << " points." << endl;
           if (List != NULL) {
-            for (LinkedNodes::const_iterator Runner = List->begin(); Runner != List->end(); Runner++) {
+            for (LinkedCell::LinkedNodes::const_iterator Runner = List->begin(); Runner != List->end(); Runner++) {
               Walker = AtomMap[(*Runner)->nr];
-              //Log() << Verbose(0) << "Current Atom is " << *Walker << "." << endl;
+//              Log() << Verbose(0) << "Current Atom is " << *Walker << "." << endl;
               // 3c. check for possible bond between each atom in this and every one in the 27 cells
               for (n[0] = -1; n[0] <= 1; n[0]++)
                 for (n[1] = -1; n[1] <= 1; n[1]++)
                   for (n[2] = -1; n[2] <= 1; n[2]++) {
-                    const LinkedNodes *OtherList = LC->GetRelativeToCurrentCell(n);
-                    //Log() << Verbose(2) << "Current relative cell is " << LC->n[0] << ", " << LC->n[1] << ", " << LC->n[2] << " with No. " << LC->index << " containing " << List->size() << " points." << endl;
+                    const LinkedCell::LinkedNodes *OtherList = LC->GetRelativeToCurrentCell(n);
+//                    Log() << Verbose(2) << "Current relative cell is " << LC->n[0] << ", " << LC->n[1] << ", " << LC->n[2] << " with No. " << LC->index << " containing " << List->size() << " points." << endl;
                     if (OtherList != NULL) {
-                      for (LinkedNodes::const_iterator OtherRunner = OtherList->begin(); OtherRunner != OtherList->end(); OtherRunner++) {
+                      for (LinkedCell::LinkedNodes::const_iterator OtherRunner = OtherList->begin(); OtherRunner != OtherList->end(); OtherRunner++) {
                         if ((*OtherRunner)->nr > Walker->nr) {
                           OtherWalker = AtomMap[(*OtherRunner)->nr];
-                          //Log() << Verbose(1) << "Checking distance " << OtherWalker->x.PeriodicDistanceSquared(&(Walker->x), cell_size) << " against typical bond length of " << bonddistance*bonddistance << "." << endl;
+//                          Log() << Verbose(0) << "Current other Atom is " << *OtherWalker << "." << endl;
+                          const double distance = OtherWalker->x.PeriodicDistanceSquared(Walker->x, cell_size);
+//                          Log() << Verbose(1) << "Checking distance " << distance << " against typical bond length of " << bonddistance*bonddistance << "." << endl;
                           (BG->*minmaxdistance)(Walker, OtherWalker, MinDistance, MaxDistance, IsAngstroem);
-                          const double distance = OtherWalker->x.PeriodicDistanceSquared(&(Walker->x), cell_size);
                           const bool status = (distance <= MaxDistance * MaxDistance) && (distance >= MinDistance * MinDistance);
-                          if ((OtherWalker->father->nr > Walker->father->nr) && (status)) { // create bond if distance is smaller
-                            //Log() << Verbose(1) << "Adding Bond between " << *Walker << " and " << *OtherWalker << " in distance " << sqrt(distance) << "." << endl;
-                            AddBond(Walker->father, OtherWalker->father, 1); // also increases molecule::BondCount
+//                          Log() << Verbose(1) << "MinDistance is " << MinDistance << " and MaxDistance is " << MaxDistance << "." << endl;
+                          if (OtherWalker->father->nr > Walker->father->nr) {
+                            if (status) { // create bond if distance is smaller
+//                              Log() << Verbose(1) << "Adding Bond between " << *Walker << " and " << *OtherWalker << " in distance " << sqrt(distance) << "." << endl;
+                              AddBond(Walker->father, OtherWalker->father, 1); // also increases molecule::BondCount
+                            } else {
+//                              Log() << Verbose(1) << "Not Adding: distance too great." << endl;
+                            }
                           } else {
-                            //Log() << Verbose(1) << "Not Adding: Wrong label order or distance too great." << endl;
+//                            Log() << Verbose(1) << "Not Adding: Wrong order of labels." << endl;
                           }
                         }
@@ -181,8 +190,8 @@
     Free(&AtomMap);
     delete (LC);
-    Log() << Verbose(1) << "I detected " << BondCount << " bonds in the molecule with distance " << BondDistance << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "I detected " << BondCount << " bonds in the molecule with distance " << BondDistance << "." << endl);
 
     // correct bond degree by comparing valence and bond degree
-    Log() << Verbose(2) << "Correcting bond degree ... " << endl;
+    DoLog(2) && (Log() << Verbose(2) << "Correcting bond degree ... " << endl);
     CorrectBondDegree();
 
@@ -190,6 +199,6 @@
     ActOnAllAtoms( &atom::OutputBondOfAtom );
   } else
-    Log() << Verbose(1) << "AtomCount is " << AtomCount << ", thus no bonds, no connections!." << endl;
-  Log() << Verbose(0) << "End of CreateAdjacencyList." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "AtomCount is " << AtomCount << ", thus no bonds, no connections!." << endl);
+  DoLog(0) && (Log() << Verbose(0) << "End of CreateAdjacencyList." << endl);
   if (free_BG)
     delete(BG);
@@ -202,11 +211,11 @@
 void molecule::OutputBondsList() const
 {
-  Log() << Verbose(1) << endl << "From contents of bond chain list:";
+  DoLog(1) && (Log() << Verbose(1) << endl << "From contents of bond chain list:");
   bond *Binder = first;
   while (Binder->next != last) {
     Binder = Binder->next;
-    Log() << Verbose(0) << *Binder << "\t" << endl;
-  }
-  Log() << Verbose(0) << endl;
+    DoLog(0) && (Log() << Verbose(0) << *Binder << "\t" << endl);
+  }
+  DoLog(0) && (Log() << Verbose(0) << endl);
 }
 ;
@@ -225,14 +234,14 @@
 
   if (BondCount != 0) {
-    Log() << Verbose(1) << "Correcting Bond degree of each bond ... " << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Correcting Bond degree of each bond ... " << endl);
     do {
       OldNo = No;
       No = SumPerAtom( &atom::CorrectBondDegree );
     } while (OldNo != No);
-    Log() << Verbose(0) << " done." << endl;
+    DoLog(0) && (Log() << Verbose(0) << " done." << endl);
   } else {
-    Log() << Verbose(1) << "BondCount is " << BondCount << ", no bonds between any of the " << AtomCount << " atoms." << endl;
-  }
-  Log() << Verbose(0) << No << " bonds could not be corrected." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "BondCount is " << BondCount << ", no bonds between any of the " << AtomCount << " atoms." << endl);
+  }
+  DoLog(0) && (Log() << Verbose(0) << No << " bonds could not be corrected." << endl);
 
   return (No);
@@ -253,5 +262,5 @@
   bond *Binder = first;
   if ((Binder->next != last) && (Binder->next->Type == Undetermined)) {
-    Log() << Verbose(0) << "No Depth-First-Search analysis performed so far, calling ..." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "No Depth-First-Search analysis performed so far, calling ..." << endl);
     Subgraphs = DepthFirstSearchAnalysis(BackEdgeStack);
     while (Subgraphs->next != NULL) {
@@ -308,5 +317,5 @@
     Walker->GraphNr = DFS.CurrentGraphNr;
     Walker->LowpointNr = DFS.CurrentGraphNr;
-    Log() << Verbose(1) << "Setting Walker[" << Walker->Name << "]'s number to " << Walker->GraphNr << " with Lowpoint " << Walker->LowpointNr << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Setting Walker[" << Walker->Name << "]'s number to " << Walker->GraphNr << " with Lowpoint " << Walker->LowpointNr << "." << endl);
     DFS.AtomStack->Push(Walker);
     DFS.CurrentGraphNr++;
@@ -335,9 +344,9 @@
     if (Binder == NULL)
       break;
-    Log() << Verbose(2) << "Current Unused Bond is " << *Binder << "." << endl;
+    DoLog(2) && (Log() << Verbose(2) << "Current Unused Bond is " << *Binder << "." << endl);
     // (4) Mark Binder used, ...
     Binder->MarkUsed(black);
     OtherAtom = Binder->GetOtherAtom(Walker);
-    Log() << Verbose(2) << "(4) OtherAtom is " << OtherAtom->Name << "." << endl;
+    DoLog(2) && (Log() << Verbose(2) << "(4) OtherAtom is " << OtherAtom->Name << "." << endl);
     if (OtherAtom->GraphNr != -1) {
       // (4a) ... if "other" atom has been visited (GraphNr != 0), set lowpoint to minimum of both, go to (3)
@@ -345,5 +354,5 @@
       DFS.BackEdgeStack->Push(Binder);
       Walker->LowpointNr = (Walker->LowpointNr < OtherAtom->GraphNr) ? Walker->LowpointNr : OtherAtom->GraphNr;
-      Log() << Verbose(3) << "(4a) Visited: Setting Lowpoint of Walker[" << Walker->Name << "] to " << Walker->LowpointNr << "." << endl;
+      DoLog(3) && (Log() << Verbose(3) << "(4a) Visited: Setting Lowpoint of Walker[" << Walker->Name << "] to " << Walker->LowpointNr << "." << endl);
     } else {
       // (4b) ... otherwise set OtherAtom as Ancestor of Walker and Walker as OtherAtom, go to (2)
@@ -351,5 +360,5 @@
       OtherAtom->Ancestor = Walker;
       Walker = OtherAtom;
-      Log() << Verbose(3) << "(4b) Not Visited: OtherAtom[" << OtherAtom->Name << "]'s Ancestor is now " << OtherAtom->Ancestor->Name << ", Walker is OtherAtom " << OtherAtom->Name << "." << endl;
+      DoLog(3) && (Log() << Verbose(3) << "(4b) Not Visited: OtherAtom[" << OtherAtom->Name << "]'s Ancestor is now " << OtherAtom->Ancestor->Name << ", Walker is OtherAtom " << OtherAtom->Name << "." << endl);
       break;
     }
@@ -373,5 +382,5 @@
 
   // (5) if Ancestor of Walker is ...
-  Log() << Verbose(1) << "(5) Number of Walker[" << Walker->Name << "]'s Ancestor[" << Walker->Ancestor->Name << "] is " << Walker->Ancestor->GraphNr << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "(5) Number of Walker[" << Walker->Name << "]'s Ancestor[" << Walker->Ancestor->Name << "] is " << Walker->Ancestor->GraphNr << "." << endl);
 
   if (Walker->Ancestor->GraphNr != DFS.Root->GraphNr) {
@@ -380,23 +389,23 @@
       // (6a) set Ancestor's Lowpoint number to minimum of of its Ancestor and itself, go to Step(8)
       Walker->Ancestor->LowpointNr = (Walker->Ancestor->LowpointNr < Walker->LowpointNr) ? Walker->Ancestor->LowpointNr : Walker->LowpointNr;
-      Log() << Verbose(2) << "(6) Setting Walker[" << Walker->Name << "]'s Ancestor[" << Walker->Ancestor->Name << "]'s Lowpoint to " << Walker->Ancestor->LowpointNr << "." << endl;
+      DoLog(2) && (Log() << Verbose(2) << "(6) Setting Walker[" << Walker->Name << "]'s Ancestor[" << Walker->Ancestor->Name << "]'s Lowpoint to " << Walker->Ancestor->LowpointNr << "." << endl);
     } else {
       // (7) (Ancestor of Walker is a separating vertex, remove all from stack till Walker (including), these and Ancestor form a component
       Walker->Ancestor->SeparationVertex = true;
-      Log() << Verbose(2) << "(7) Walker[" << Walker->Name << "]'s Ancestor[" << Walker->Ancestor->Name << "]'s is a separating vertex, creating component." << endl;
+      DoLog(2) && (Log() << Verbose(2) << "(7) Walker[" << Walker->Name << "]'s Ancestor[" << Walker->Ancestor->Name << "]'s is a separating vertex, creating component." << endl);
       mol->SetNextComponentNumber(Walker->Ancestor, DFS.ComponentNumber);
-      Log() << Verbose(3) << "(7) Walker[" << Walker->Name << "]'s Ancestor's Compont is " << DFS.ComponentNumber << "." << endl;
+      DoLog(3) && (Log() << Verbose(3) << "(7) Walker[" << Walker->Name << "]'s Ancestor's Compont is " << DFS.ComponentNumber << "." << endl);
       mol->SetNextComponentNumber(Walker, DFS.ComponentNumber);
-      Log() << Verbose(3) << "(7) Walker[" << Walker->Name << "]'s Compont is " << DFS.ComponentNumber << "." << endl;
+      DoLog(3) && (Log() << Verbose(3) << "(7) Walker[" << Walker->Name << "]'s Compont is " << DFS.ComponentNumber << "." << endl);
       do {
         OtherAtom = DFS.AtomStack->PopLast();
         LeafWalker->Leaf->AddCopyAtom(OtherAtom);
         mol->SetNextComponentNumber(OtherAtom, DFS.ComponentNumber);
-        Log() << Verbose(3) << "(7) Other[" << OtherAtom->Name << "]'s Compont is " << DFS.ComponentNumber << "." << endl;
+        DoLog(3) && (Log() << Verbose(3) << "(7) Other[" << OtherAtom->Name << "]'s Compont is " << DFS.ComponentNumber << "." << endl);
       } while (OtherAtom != Walker);
       DFS.ComponentNumber++;
     }
     // (8) Walker becomes its Ancestor, go to (3)
-    Log() << Verbose(2) << "(8) Walker[" << Walker->Name << "] is now its Ancestor " << Walker->Ancestor->Name << ", backstepping. " << endl;
+    DoLog(2) && (Log() << Verbose(2) << "(8) Walker[" << Walker->Name << "] is now its Ancestor " << Walker->Ancestor->Name << ", backstepping. " << endl);
     Walker = Walker->Ancestor;
     DFS.BackStepping = true;
@@ -422,12 +431,12 @@
     //DFS.AtomStack->Output(out);
     mol->SetNextComponentNumber(DFS.Root, DFS.ComponentNumber);
-    Log() << Verbose(3) << "(9) Root[" << DFS.Root->Name << "]'s Component is " << DFS.ComponentNumber << "." << endl;
+    DoLog(3) && (Log() << Verbose(3) << "(9) Root[" << DFS.Root->Name << "]'s Component is " << DFS.ComponentNumber << "." << endl);
     mol->SetNextComponentNumber(Walker, DFS.ComponentNumber);
-    Log() << Verbose(3) << "(9) Walker[" << Walker->Name << "]'s Component is " << DFS.ComponentNumber << "." << endl;
+    DoLog(3) && (Log() << Verbose(3) << "(9) Walker[" << Walker->Name << "]'s Component is " << DFS.ComponentNumber << "." << endl);
     do {
       OtherAtom = DFS.AtomStack->PopLast();
       LeafWalker->Leaf->AddCopyAtom(OtherAtom);
       mol->SetNextComponentNumber(OtherAtom, DFS.ComponentNumber);
-      Log() << Verbose(3) << "(7) Other[" << OtherAtom->Name << "]'s Compont is " << DFS.ComponentNumber << "." << endl;
+      DoLog(3) && (Log() << Verbose(3) << "(7) Other[" << OtherAtom->Name << "]'s Compont is " << DFS.ComponentNumber << "." << endl);
     } while (OtherAtom != Walker);
     DFS.ComponentNumber++;
@@ -436,7 +445,7 @@
     Walker = DFS.Root;
     Binder = mol->FindNextUnused(Walker);
-    Log() << Verbose(1) << "(10) Walker is Root[" << DFS.Root->Name << "], next Unused Bond is " << Binder << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "(10) Walker is Root[" << DFS.Root->Name << "], next Unused Bond is " << Binder << "." << endl);
     if (Binder != NULL) { // Root is separation vertex
-      Log() << Verbose(1) << "(11) Root is a separation vertex." << endl;
+      DoLog(1) && (Log() << Verbose(1) << "(11) Root is a separation vertex." << endl);
       Walker->SeparationVertex = true;
     }
@@ -493,5 +502,7 @@
   bond *Binder = NULL;
 
-  Log() << Verbose(0) << "Begin of DepthFirstSearchAnalysis" << endl;
+  if (AtomCount == 0)
+    return SubGraphs;
+  DoLog(0) && (Log() << Verbose(0) << "Begin of DepthFirstSearchAnalysis" << endl);
   DepthFirstSearchAnalysis_Init(DFS, this);
 
@@ -503,5 +514,5 @@
     // put into new subgraph molecule and add this to list of subgraphs
     LeafWalker = new MoleculeLeafClass(LeafWalker);
-    LeafWalker->Leaf = new molecule(elemente);
+    LeafWalker->Leaf = World::getInstance().createMolecule();
     LeafWalker->Leaf->AddCopyAtom(DFS.Root);
 
@@ -515,5 +526,5 @@
 
         if (Binder == NULL) {
-          Log() << Verbose(2) << "No more Unused Bonds." << endl;
+          DoLog(2) && (Log() << Verbose(2) << "No more Unused Bonds." << endl);
           break;
         } else
@@ -532,7 +543,7 @@
 
     // From OldGraphNr to CurrentGraphNr ranges an disconnected subgraph
-    Log() << Verbose(0) << "Disconnected subgraph ranges from " << OldGraphNr << " to " << DFS.CurrentGraphNr << "." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Disconnected subgraph ranges from " << OldGraphNr << " to " << DFS.CurrentGraphNr << "." << endl);
     LeafWalker->Leaf->Output((ofstream *)&cout);
-    Log() << Verbose(0) << endl;
+    DoLog(0) && (Log() << Verbose(0) << endl);
 
     // step on to next root
@@ -552,5 +563,5 @@
   // free all and exit
   DepthFirstSearchAnalysis_Finalize(DFS);
-  Log() << Verbose(0) << "End of DepthFirstSearchAnalysis" << endl;
+  DoLog(0) && (Log() << Verbose(0) << "End of DepthFirstSearchAnalysis" << endl);
   return SubGraphs;
 }
@@ -578,5 +589,5 @@
 void molecule::OutputGraphInfoPerAtom() const
 {
-  Log() << Verbose(1) << "Final graph info for each atom is:" << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Final graph info for each atom is:" << endl);
   ActOnAllAtoms( &atom::OutputGraphInfo );
 }
@@ -588,17 +599,17 @@
 void molecule::OutputGraphInfoPerBond() const
 {
-  Log() << Verbose(1) << "Final graph info for each bond is:" << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Final graph info for each bond is:" << endl);
   bond *Binder = first;
   while (Binder->next != last) {
     Binder = Binder->next;
-    Log() << Verbose(2) << ((Binder->Type == TreeEdge) ? "TreeEdge " : "BackEdge ") << *Binder << ": <";
-    Log() << Verbose(0) << ((Binder->leftatom->SeparationVertex) ? "SP," : "") << "L" << Binder->leftatom->LowpointNr << " G" << Binder->leftatom->GraphNr << " Comp.";
+    DoLog(2) && (Log() << Verbose(2) << ((Binder->Type == TreeEdge) ? "TreeEdge " : "BackEdge ") << *Binder << ": <");
+    DoLog(0) && (Log() << Verbose(0) << ((Binder->leftatom->SeparationVertex) ? "SP," : "") << "L" << Binder->leftatom->LowpointNr << " G" << Binder->leftatom->GraphNr << " Comp.");
     Binder->leftatom->OutputComponentNumber();
-    Log() << Verbose(0) << " ===  ";
-    Log() << Verbose(0) << ((Binder->rightatom->SeparationVertex) ? "SP," : "") << "L" << Binder->rightatom->LowpointNr << " G" << Binder->rightatom->GraphNr << " Comp.";
+    DoLog(0) && (Log() << Verbose(0) << " ===  ");
+    DoLog(0) && (Log() << Verbose(0) << ((Binder->rightatom->SeparationVertex) ? "SP," : "") << "L" << Binder->rightatom->LowpointNr << " G" << Binder->rightatom->GraphNr << " Comp.");
     Binder->rightatom->OutputComponentNumber();
-    Log() << Verbose(0) << ">." << endl;
+    DoLog(0) && (Log() << Verbose(0) << ">." << endl);
     if (Binder->Cyclic) // cyclic ??
-      Log() << Verbose(3) << "Lowpoint at each side are equal: CYCLIC!" << endl;
+      DoLog(3) && (Log() << Verbose(3) << "Lowpoint at each side are equal: CYCLIC!" << endl);
   }
 }
@@ -674,5 +685,5 @@
   do { // look for Root
     Walker = BFS.BFSStack->PopFirst();
-    Log() << Verbose(2) << "Current Walker is " << *Walker << ", we look for SP to Root " << *BFS.Root << "." << endl;
+    DoLog(2) && (Log() << Verbose(2) << "Current Walker is " << *Walker << ", we look for SP to Root " << *BFS.Root << "." << endl);
     for (BondList::const_iterator Runner = Walker->ListOfBonds.begin(); Runner != Walker->ListOfBonds.end(); (++Runner)) {
       if ((*Runner) != BackEdge) { // only walk along DFS spanning tree (otherwise we always find SP of one being backedge Binder)
@@ -681,5 +692,5 @@
         if (OtherAtom->type->Z != 1) {
 #endif
-        Log() << Verbose(2) << "Current OtherAtom is: " << OtherAtom->Name << " for bond " << *(*Runner) << "." << endl;
+        DoLog(2) && (Log() << Verbose(2) << "Current OtherAtom is: " << OtherAtom->Name << " for bond " << *(*Runner) << "." << endl);
         if (BFS.ColorList[OtherAtom->nr] == white) {
           BFS.TouchedStack->Push(OtherAtom);
@@ -687,11 +698,11 @@
           BFS.PredecessorList[OtherAtom->nr] = Walker; // Walker is the predecessor
           BFS.ShortestPathList[OtherAtom->nr] = BFS.ShortestPathList[Walker->nr] + 1;
-          Log() << Verbose(2) << "Coloring OtherAtom " << OtherAtom->Name << " lightgray, its predecessor is " << Walker->Name << " and its Shortest Path is " << BFS.ShortestPathList[OtherAtom->nr] << " egde(s) long." << endl;
+          DoLog(2) && (Log() << Verbose(2) << "Coloring OtherAtom " << OtherAtom->Name << " lightgray, its predecessor is " << Walker->Name << " and its Shortest Path is " << BFS.ShortestPathList[OtherAtom->nr] << " egde(s) long." << endl);
           //if (BFS.ShortestPathList[OtherAtom->nr] < MinimumRingSize[Walker->GetTrueFather()->nr]) { // Check for maximum distance
-          Log() << Verbose(3) << "Putting OtherAtom into queue." << endl;
+          DoLog(3) && (Log() << Verbose(3) << "Putting OtherAtom into queue." << endl);
           BFS.BFSStack->Push(OtherAtom);
           //}
         } else {
-          Log() << Verbose(3) << "Not Adding, has already been visited." << endl;
+          DoLog(3) && (Log() << Verbose(3) << "Not Adding, has already been visited." << endl);
         }
         if (OtherAtom == BFS.Root)
@@ -699,14 +710,14 @@
 #ifdef ADDHYDROGEN
       } else {
-        Log() << Verbose(2) << "Skipping hydrogen atom " << *OtherAtom << "." << endl;
+        DoLog(2) && (Log() << Verbose(2) << "Skipping hydrogen atom " << *OtherAtom << "." << endl);
         BFS.ColorList[OtherAtom->nr] = black;
       }
 #endif
       } else {
-        Log() << Verbose(2) << "Bond " << *(*Runner) << " not Visiting, is the back edge." << endl;
+        DoLog(2) && (Log() << Verbose(2) << "Bond " << *(*Runner) << " not Visiting, is the back edge." << endl);
       }
     }
     BFS.ColorList[Walker->nr] = black;
-    Log() << Verbose(1) << "Coloring Walker " << Walker->Name << " black." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Coloring Walker " << Walker->Name << " black." << endl);
     if (OtherAtom == BFS.Root) { // if we have found the root, check whether this cycle wasn't already found beforehand
       // step through predecessor list
@@ -718,9 +729,9 @@
       }
       if (OtherAtom == BackEdge->rightatom) { // if each atom in found cycle is cyclic, loop's been found before already
-        Log() << Verbose(3) << "This cycle was already found before, skipping and removing seeker from search." << endl;
+        DoLog(3) && (Log() << Verbose(3) << "This cycle was already found before, skipping and removing seeker from search." << endl);
         do {
           OtherAtom = BFS.TouchedStack->PopLast();
           if (BFS.PredecessorList[OtherAtom->nr] == Walker) {
-            Log() << Verbose(4) << "Removing " << *OtherAtom << " from lists and stacks." << endl;
+            DoLog(4) && (Log() << Verbose(4) << "Removing " << *OtherAtom << " from lists and stacks." << endl);
             BFS.PredecessorList[OtherAtom->nr] = NULL;
             BFS.ShortestPathList[OtherAtom->nr] = -1;
@@ -756,13 +767,13 @@
     RingSize = 1;
     BFS.Root->GetTrueFather()->IsCyclic = true;
-    Log() << Verbose(1) << "Found ring contains: ";
+    DoLog(1) && (Log() << Verbose(1) << "Found ring contains: ");
     Walker = BFS.Root;
     while (Walker != BackEdge->rightatom) {
-      Log() << Verbose(0) << Walker->Name << " <-> ";
+      DoLog(0) && (Log() << Verbose(0) << Walker->Name << " <-> ");
       Walker = BFS.PredecessorList[Walker->nr];
       Walker->GetTrueFather()->IsCyclic = true;
       RingSize++;
     }
-    Log() << Verbose(0) << Walker->Name << "  with a length of " << RingSize << "." << endl << endl;
+    DoLog(0) && (Log() << Verbose(0) << Walker->Name << "  with a length of " << RingSize << "." << endl << endl);
     // walk through all and set MinimumRingSize
     Walker = BFS.Root;
@@ -776,5 +787,5 @@
       MinRingSize = RingSize;
   } else {
-    Log() << Verbose(1) << "No ring containing " << *BFS.Root << " with length equal to or smaller than " << MinimumRingSize[Walker->GetTrueFather()->nr] << " found." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "No ring containing " << *BFS.Root << " with length equal to or smaller than " << MinimumRingSize[Walker->GetTrueFather()->nr] << " found." << endl);
   }
 };
@@ -854,9 +865,9 @@
 
       }
-      Log() << Verbose(1) << "Minimum ring size of " << *Root << " is " << MinimumRingSize[Root->GetTrueFather()->nr] << "." << endl;
-    }
-    Log() << Verbose(1) << "Minimum ring size is " << MinRingSize << ", over " << NumCycles << " cycles total." << endl;
+      DoLog(1) && (Log() << Verbose(1) << "Minimum ring size of " << *Root << " is " << MinimumRingSize[Root->GetTrueFather()->nr] << "." << endl);
+    }
+    DoLog(1) && (Log() << Verbose(1) << "Minimum ring size is " << MinRingSize << ", over " << NumCycles << " cycles total." << endl);
   } else
-    Log() << Verbose(1) << "No rings were detected in the molecular structure." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "No rings were detected in the molecular structure." << endl);
 }
 ;
@@ -886,5 +897,5 @@
   //BackEdgeStack->Output(out);
 
-  Log() << Verbose(1) << "Analysing cycles ... " << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Analysing cycles ... " << endl);
   NumCycles = 0;
   while (!BackEdgeStack->IsEmpty()) {
@@ -897,5 +908,5 @@
     ResetBFSAccounting(Walker, BFS);
 
-    Log() << Verbose(1) << "---------------------------------------------------------------------------------------------------------" << endl;
+    DoLog(1) && (Log() << Verbose(1) << "---------------------------------------------------------------------------------------------------------" << endl);
     OtherAtom = NULL;
     CyclicStructureAnalysis_CyclicBFSFromRootToRoot(BackEdge, BFS);
@@ -927,9 +938,9 @@
     }
     if (i == vertex->ListOfBonds.size()) {
-      eLog() << Verbose(0) << "Error: All Component entries are already occupied!" << endl;
+      DoeLog(0) && (eLog()<< Verbose(0) << "Error: All Component entries are already occupied!" << endl);
       performCriticalExit();
     }
   } else {
-    eLog() << Verbose(0) << "Error: Given vertex is NULL!" << endl;
+    DoeLog(0) && (eLog()<< Verbose(0) << "Error: Given vertex is NULL!" << endl);
     performCriticalExit();
   }
@@ -969,8 +980,8 @@
 void OutputAlreadyVisited(int *list)
 {
-  Log() << Verbose(4) << "Already Visited Bonds:\t";
+  DoLog(4) && (Log() << Verbose(4) << "Already Visited Bonds:\t");
   for (int i = 1; i <= list[0]; i++)
-    Log() << Verbose(0) << list[i] << "  ";
-  Log() << Verbose(0) << endl;
+    DoLog(0) && (Log() << Verbose(0) << list[i] << "  ");
+  DoLog(0) && (Log() << Verbose(0) << endl);
 }
 ;
@@ -978,9 +989,9 @@
 /** Storing the bond structure of a molecule to file.
  * Simply stores Atom::nr and then the Atom::nr of all bond partners per line.
- * \param *out output stream for debugging
  * \param *path path to file
+ * \param *filename name of file
  * \return true - file written successfully, false - writing failed
  */
-bool molecule::StoreAdjacencyToFile(char *path)
+bool molecule::StoreAdjacencyToFile(char *path, char *filename)
 {
   ofstream AdjacencyFile;
@@ -988,14 +999,17 @@
   bool status = true;
 
-  line << path << "/" << FRAGMENTPREFIX << ADJACENCYFILE;
+  if (path != NULL)
+    line << path << "/" << filename;
+  else
+    line << filename;
   AdjacencyFile.open(line.str().c_str(), ios::out);
-  Log() << Verbose(1) << "Saving adjacency list ... ";
+  DoLog(1) && (Log() << Verbose(1) << "Saving adjacency list ... ");
   if (AdjacencyFile != NULL) {
     AdjacencyFile << "m\tn" << endl;
     ActOnAllAtoms(&atom::OutputAdjacency, &AdjacencyFile);
     AdjacencyFile.close();
-    Log() << Verbose(1) << "done." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "done." << endl);
   } else {
-    Log() << Verbose(1) << "failed to open file " << line.str() << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "failed to open file " << line.str() << "." << endl);
     status = false;
   }
@@ -1007,9 +1021,9 @@
 /** Storing the bond structure of a molecule to file.
  * Simply stores Atom::nr and then the Atom::nr of all bond partners, one per line.
- * \param *out output stream for debugging
  * \param *path path to file
+ * \param *filename name of file
  * \return true - file written successfully, false - writing failed
  */
-bool molecule::StoreBondsToFile(char *path)
+bool molecule::StoreBondsToFile(char *path, char *filename)
 {
   ofstream BondFile;
@@ -1017,14 +1031,17 @@
   bool status = true;
 
-  line << path << "/" << FRAGMENTPREFIX << ADJACENCYFILE;
+  if (path != NULL)
+    line << path << "/" << filename;
+  else
+    line << filename;
   BondFile.open(line.str().c_str(), ios::out);
-  Log() << Verbose(1) << "Saving adjacency list ... ";
+  DoLog(1) && (Log() << Verbose(1) << "Saving adjacency list ... ");
   if (BondFile != NULL) {
     BondFile << "m\tn" << endl;
     ActOnAllAtoms(&atom::OutputBonds, &BondFile);
     BondFile.close();
-    Log() << Verbose(1) << "done." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "done." << endl);
   } else {
-    Log() << Verbose(1) << "failed to open file " << line.str() << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "failed to open file " << line.str() << "." << endl);
     status = false;
   }
